<?php

namespace Drupal\cf_neighbourhoods\Element;

use Drupal\Core\Form\FormStateInterface;

/**
 * Tweaks the CommerceGuys address form element for local use with neighbourhoods
 *
 * @FormElement("cforge_address")
 */
class Address extends \Drupal\address\Element\Address {

  /**
   * Override the address widget assuming there is no choice of country and
   * neighbourhood is a dropdown. Restrict the available countries to those in
   * config.
   */
  public static function processAddress(array &$element, FormStateInterface $form_state, array &$complete_form) {
    $element = parent::processAddress($element, $form_state, $complete_form);
    $element['country_code']['#type'] = 'hidden';
    unset($element['country_code']['#options']);
    $element['dependent_locality']['#type'] = 'cf_neighbourhood_select';

    $countries = \Drupal::service('address.country_repository')->getList();
    $country = $countries[$element['#value']['country_code']];
    if (isset($element['state']))   {
      $element['state']['#suffix'] = $country;
    }
    else {
      $element['postal_code']['#suffix'] = $country;
    }
    //For now just hope that covers all country formats
    return $element;
  }


}